module Config.ForceDirectedGraph exposing (Entity, Model, Msg(..), TaskError(..))

import Force
import Graph exposing (Graph, NodeId)
import Svg.Attributes exposing (calcMode)


type Msg
    = RecalcStart
    | Highlight String
    | ChangeYear Int
    | ChangeForces Int
    | RecalcEnd (Result TaskError Model)
    | SetLoading Bool


type TaskError
    = TaskFailed


type alias Model =
    { graph : Graph Entity ()
    , simulation : Force.State NodeId
    , tickCount : Int
    , loading : Bool
    , highlight : String
    , year : Int
    }


type alias Entity =
    Force.Entity NodeId { value : String }
